JF1050 = {};

function JF1050.prerequisitesPresent(specializations)
return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function JF1050:load(xmlFile)

	self.drum = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index"));
	
	local rotationPartNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart1#index"));
    if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#rotTime"), 2)*1000;
        self.rotationPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#touchRotLimit"), 10));
    end;
	local rotationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
    if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
    end;
	
	local rotationPartNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart3#index"));
    if rotationPartNode3 ~= nil then
        self.rotationPart3 = {};
        self.rotationPart3.node = rotationPartNode3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#minRot"));
        self.rotationPart3.minRot = {};
        self.rotationPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#maxRot"));
        self.rotationPart3.maxRot = {};
        self.rotationPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#rotTime"), 2)*1000;
        self.rotationPart3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#touchRotLimit"), 10));
    end;
	local rotationPartNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart4#index"));
    if rotationPartNode4 ~= nil then
        self.rotationPart4 = {};
        self.rotationPart4.node = rotationPartNode4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#minRot"));
        self.rotationPart4.minRot = {};
        self.rotationPart4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#maxRot"));
        self.rotationPart4.maxRot = {};
        self.rotationPart4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#rotTime"), 2)*1000;
        self.rotationPart4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#touchRotLimit"), 10));
    end;
	local rotationPartNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart5#index"));
    if rotationPartNode5 ~= nil then
        self.rotationPart5 = {};
        self.rotationPart5.node = rotationPartNode5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart5#minRot"));
        self.rotationPart5.minRot = {};
        self.rotationPart5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart5#maxRot"));
        self.rotationPart5.maxRot = {};
        self.rotationPart5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart5#rotTime"), 2)*1000;
        self.rotationPart5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart5#touchRotLimit"), 10));
    end;
	local rotationPartNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart6#index"));
    if rotationPartNode6 ~= nil then
        self.rotationPart6 = {};
        self.rotationPart6.node = rotationPartNode6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#minRot"));
        self.rotationPart6.minRot = {};
        self.rotationPart6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#maxRot"));
        self.rotationPart6.maxRot = {};
        self.rotationPart6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#rotTime"), 2)*1000;
        self.rotationPart6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#touchRotLimit"), 10));
    end;
	
		local translationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart2#index"));
		if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);
		self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;

	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory);
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
	
	self.pipeParticleSystems = {};
    local pipeParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.pipeParticleSystems#count"), 0);
    for i=1, pipeParticleSystemCount do
        local namei = string.format("vehicle.pipeParticleSystems.particle%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.pipeParticleSystems, namei, nodei, false, nil, self.baseDirectory)
    end;
	
	self.trailerRaycastNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.unloadingPoint#index"));
	self.workSoundActive = false;
	self.rotationPart1Max = true;
	self.rotationPart2Max = true;
	self.rotationPart3Max = true;
	self.rotationPart4Max = true;
	self.rotationPart5Max = true;
	self.rotationPart6Max = true;
	self.translationPart2Max = true;
	self.on = false;
	self.lastArea = 0;
	self.findTrailerRaycastCallback = JF1050.findTrailerRaycastCallback;
	self.isActive = false;
	
end;

function JF1050:delete()
	if self.workSoundActive then
		stopSample(self.workSound); 
		self.workSoundActive = false; 
	end;
end;

function JF1050:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JF1050:keyEvent(unicode, sym, modifier, isDown)

  if isDown and sym == Input.KEY_b   then
  
		self.on = not self.on;
	end;
	if sym == Input.KEY_KP_4 then
	
		self.rotationJF1Max = isDown;
	end;
	if sym == Input.KEY_KP_1 then
	
		self.rotationJF1Min = isDown;
	end;
		if sym == Input.KEY_KP_2 then
		
		self.rotationJF3Max = isDown;
	end;
	if sym == Input.KEY_KP_3 then
	
		self.rotationJF3Min = isDown;
	end;
	if sym == Input.KEY_6 then
	
		self.rotationJF2Max = isDown;
		self.rotationJF4Max = isDown;
		self.rotationJF5Max = isDown;
		self.rotationJF6Max = isDown;
	end;
		if sym == Input.KEY_7 then
		
		self.rotationJF2Min = isDown;
		self.rotationJF4Min = isDown;
		self.rotationJF5Min = isDown;
		self.rotationJF6Min = isDown;
	end;
		if isDown and sym == Input.KEY_j   then
		
		self.translationJFT2Max = not self.translationJFT2Min;
		end;
end;

function JF1050:update(dt)

	Utils.setEmittingState(self.pipeParticleSystems, false);
	if self.attacherVehicle ~= nil then
			if self.on then
				self.isActive = true;
			else
				self.isActive = false;
			end;
	else
		self.isActive = false;
	end;
		
	if self.rotationPart1.node ~= nil and (self.rotationJF1Max or self.rotationJF1Min) then
		local x, y, z = getRotation(self.rotationPart1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart1.node, unpack(newRot));
	end;
	if self.rotationPart2.node ~= nil and (self.rotationJF2Max or self.rotationJF2Min) then
		local x, y, z = getRotation(self.rotationPart2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart2.node, unpack(newRot));
	end;
		if self.rotationPart3.node ~= nil and (self.rotationJF3Max or self.rotationJF3Min) then
		local x, y, z = getRotation(self.rotationPart3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart3.maxRot, self.rotationPart3.minRot, 3, self.rotationPart3.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart3.node, unpack(newRot));
	end;
		if self.rotationPart4.node ~= nil and (self.rotationJF4Max or self.rotationJF4Min) then
		local x, y, z = getRotation(self.rotationPart4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart4.maxRot, self.rotationPart4.minRot, 3, self.rotationPart4.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart4.node, unpack(newRot));
	end;
		if self.rotationPart5.node ~= nil and (self.rotationJF5Max or self.rotationJF5Min) then
		local x, y, z = getRotation(self.rotationPart5.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart5.maxRot, self.rotationPart5.minRot, 3, self.rotationPart5.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart3.node, unpack(newRot));
	end;
		if self.rotationPart6.node ~= nil and (self.rotationJF6Max or self.rotationJF6Min) then
		local x, y, z = getRotation(self.rotationPart6.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart6.maxRot, self.rotationPart6.minRot, 3, self.rotationPart6.rotTime*2, dt, not self.rotationMax);
		setRotation(self.rotationPart6.node, unpack(newRot));
	end;
		if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
		end;		
		
	if self.isActive == true then
		rotate(self.drum, 180 * 300 * 8.9, 0, 0);
		if not self.workSoundActive then
			setSamplePitch(self.workSound, self.workSoundPitchOffset); 
			playSample(self.workSound, 0, 1, 0); 
			self.workSoundActive = true; 
		end;
	else
		if self.workSoundActive then
			stopSample(self.workSound); 
			self.workSoundActive = false; 
		end;
	end;
	
	if self.attacherVehicle ~= nil then 
		if self.attacherVehicle.lastSpeed*3600 < 40 and self.isActive == true then
				
			local realArea = 0;
			self.currentFruitType = FruitUtil.FRUITTYPE_GRASS;
			for k,area in pairs(self.cuttingAreas) do
				local x,y,z = getWorldTranslation(area.start);
				local x1,y1,z1 = getWorldTranslation(area.width);
				local x2,y2,z2 = getWorldTranslation(area.height);
				Utils.updateFruitCutShortArea(self.currentFruitType, x, z, x1, z1, x2, z2, 1);
				local area = Utils.cutFruitArea(self.currentFruitType, x, z, x1, z1, x2, z2);
					if area > 0 then
						local spray = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.sprayChannel, x, z, x1, z1, x2, z2);
						local multi = 1;
							if spray > 0 then
								multi = 2;
							end;
                        self.lastArea = self.lastArea + area*multi;
                        realArea = realArea + area/g_currentMission.maxFruitValue;
						if realArea > 0 then
							Utils.setEmittingState(self.pipeParticleSystems, true)
						else
							Utils.setEmittingState(self.pipeParticleSystems, false)
						end;
					end;
        end;
        local pixelToQm = 2048 / 4096 * 2048 / 4096; -- 4096px are mapped to 2048m
        local qm = realArea*pixelToQm;
        local ha = qm/10000;

        g_currentMission.missionStats.hectaresThreshedTotal = g_currentMission.missionStats.hectaresThreshedTotal + ha;
        g_currentMission.missionStats.hectaresThreshedSession = g_currentMission.missionStats.hectaresThreshedSession + ha;
		g_currentMission.missionStats.threshingDurationTotal = g_currentMission.missionStats.threshingDurationTotal + dt/(1000*60);
        g_currentMission.missionStats.threshingDurationSession= g_currentMission.missionStats.threshingDurationSession + dt/(1000*60);

		self.lastUnloadingTrailer = nil;
		self.trailerFound = 0;
            local x,y,z = getWorldTranslation(self.trailerRaycastNode);
            raycastAll(x, y, z, 0, -0.5, 0, "findTrailerRaycastCallback", 10, self);
            local trailer = g_currentMission.objectToTrailer[self.trailerFound];
            self.lastUnloadingTrailer = trailer;
			if self.trailerFound == 0 or trailer == nil or not trailer:allowFillType(FruitUtil.FRUITTYPE_GRASS, true) or not trailer.allowFillFromAir then
                --Utils.setEmittingState(self.pipeParticleSystems, false)
            else
				local fruitType = FruitUtil.FRUITTYPE_GRASS;
				local pixelToQm = 2048 / 4096 * 2048 / 4096  / g_currentMission.maxFruitValue; -- 4096px are mapped to 2048m
                local literPerQm = 1;
                if (fruitType ~= FruitUtil.FRUITTYPE_UNKNOWN) then
                    literPerQm = FruitUtil.fruitIndexToDesc[fruitType].literPerQm * (1 + 0.5 * (3 - g_currentMission.missionStats.difficulty));
                end;
                local qm = realArea*pixelToQm;
                local deltaLevel = qm*literPerQm*3;
				trailer:setFillLevel(trailer.fillLevel+deltaLevel, FruitUtil.FRUITTYPE_SILAGE);
            end;
		--else
		--	Utils.setEmittingState(self.pipeParticleSystems, false);
		end;
	--else
	--	Utils.setEmittingState(self.pipeParticleSystems, false);
	end;
	
end;

function JF1050:draw()

if self.on == true then
	g_currentMission:addExtraPrintText("Key B: Turn JF1050 harvestor Off");
	g_currentMission:addExtraPrintText("Key: Neck/Left 1 Right 4/ Flap /Up 2 Dwn 3/ Drawbar 6");
else
	g_currentMission:addExtraPrintText("Key B: Turn JF1050 harvestor On");
end;

end;

function JF1050:findTrailerRaycastCallback(transformId, x, y, z, distance)

    if getUserAttribute(transformId, "vehicleType") == 2 then
        self.trailerFound = transformId;
    end;

    return false;

end;